<?php
const EPSILON = 0.00001;
			
$colorRGBMap = array(
 'white' => 'ffffff',
 'red' => 'ff0000',
 'green' => '00ff00',
 'blue' => '0000ff',
);
	
function getColorRGB($param) {
	global $colorRGBMap;

	if (array_key_exists($param, $colorRGBMap)) {
		return $colorRGBMap[$param];
	}
	return $param;
}

class colorRGBA {
var $r;
var $g;
var $b;

	public function __construct($str) {
		$this->r = floatval(hexdec(substr($str,0,2))) / 255.0;
		$this->g = floatval(hexdec(substr($str,2,2))) / 255.0;
		$this->b = floatval(hexdec(substr($str,4,2))) / 255.0;
	}

	public function toHSB() {
		
		$hsb = new colorHSB();

		$mx = max($this->r, $this->g, $this->b);
		$mn = min($this->r, $this->g, $this->b);
		$delta = $mx - $mn;

		if ($delta < EPSILON) {
			$hsb->h = 0;
		} else {
			if ($this->r == $mx) {
				$hue = ($this->g - $this->b) / $delta;
			} else if ($this->g == $mx) {
				$hue = 2 + ($this->b - $this->r) / $delta;
			} else {
				$hue = 4 + ($this->r - $this->g) / $delta;
			}
			//
			$hue *= 60;
			if ( $hue < 0) $hue += 360;
			$hsb->h = $hue / 360;
		}

		$hsb->s = ($mx == 0) ? 0 : ($delta / $mx);
		$hsb->b = $mx;

		return $hsb;
	}

};

class colorHSB {
var $h;
var $s;
var $b;

};
?>
