<?php
require_once 'system/setup.conf';
require_once 'warp/warplib/applet.inc';
require_once 'warp/warplib/appletutils.inc';

require_once 'domhelper.inc';
require_once 'getdata.inc';
require_once 'vbook.php';
require_once 'vcard.php';


class Warp_Contacts_Applet extends Warp_Applet
{
var $snList;
var $nameList;// full name, as presented on-screen, used to list the names (at top of screen, and down it)
var $show;
var $xpath;
var $valid;
var $personList; // pre-formated (ugh!) information about the person
var $errorMessage;

    function Warp_Contacts_Applet($caption = "Contact Information")
    {
        parent::__construct($caption);
        $this->errorMessage = "";
    }

    function prepare(&$appMan)
    {
        $user = $appMan->getAuth()->getUser();
        if ($user == "") {
           $user = "public";
        }

        $contactsFileName = getMinervaRoot()."/etc/users/$user/contacts.xml";
        $imageDir = $this->getAppletFileName("contacts/images/");

        $dom = new DOMDocument('1.0');
        $this->valid = @$dom->load($contactsFileName);
        if ($this->valid) {
           $this->xpath = new DOMXPath($dom);

           $this->snList = PersonalData::getSortedNameIndex($this->xpath);
           $this->nameList = PersonalData::getNameList($this->xpath);
           $this->personList = PersonalData::getPersonNodeList($this->xpath, $imageDir);
           $this->show = $appMan->QueryParameter($this, "show");
        } else {
           $this->errorMessage = "There is an error in the XML '$contactsFileName'. Please fix.";
		  }


        $contactsFileName = getMinervaRoot()."/etc/users/$user/contacts.vcf";
        $lines = file($contactsFileName);
        if ($lines) {
           $cards = parse_vcards($lines);
           foreach ($cards as $card_name => $card) {
               $personSurname = $card_name;
               $name = join(' ', array_reverse($card_name));
               $idx = count($this->snList);
               $this->snList[$idx] = $personSurname;

               $this->nameList[$idx] = $card_name;

               // V1. only worry about phone, because the VCF comes from my phone. If you want the rest
               // please submit a patch :)
               $properties = $card->getProperties("TEL");
               if ($properties) {
                   foreach ($properties as $property) {
                       $show = true;
                       $types = $property->params['TYPE'];
                       if ($types) {
                           foreach ($types as $type) {
                               if (in_array_case($type, $hide)) {
                                   $show = false;
                                   break;
                               }
                           }
                       }
                       if ($show) {
                           $details = get_vcard_property($property, "", $hide);
                           $this->personList[$idx] .= "<img src=$imageDir/phone.png alt=Phone>" . $details ."<br>";
                       }
                   }
               } //fi
           } // foreach
        } // fi

    }

    function renderPanel(&$appMan) 
    {
        return "";
    }

    function renderWindow(&$appMan)
    {
        $this->prepare($appMan);

        if (!$this->valid) {
           return $this->errorMessage."\nNo contacts data...";
        }
        $main = "";

        //
        // The first bar is the alphabet, followed by 'all'
        //
        $alpha = '';
        for ($i="A"; $i != "AA"; $i++) {
            $alpha.= $appMan->getAppletLink($this, "show", $i, "&nbsp;$i&nbsp;");
        }
        $alpha .= $appMan->getAppletLink($this, "show", "all", "All");

        $main.= "<div align=center>$alpha</div><hr/>";

        //
        // We then show all the individual names under this letter
        //
        $nameBar = $this->show;
        foreach($this->snList as $k=>$v) {
           if (strcasecmp($this->show,"all")==0 || strcasecmp($this->show,substr($v,0,1))==0) {
              $nameBar .= " - ";
              $nameBar .= "<a href=#n$k>";
              $nameBar .= $this->nameList[$k];
              $nameBar .= "</a>";
           }
        }
        $main.= "<div align=center>$nameBar</div><hr/>";

        if ($this->show == "") {
           $main .= "Select a letter to view contacts...";
        }

        //
        // And finally, the contact details, themselves
        //
        $contacts = "";
        foreach($this->snList as $k=>$v) {
           if (strcasecmp($this->show,"all")==0 || strcasecmp($this->show,substr($v,0,1))==0) {
              $contacts .= "<table border=0 cellspacing=0 width=90%>";
              $contacts .= "<tr><td colspan=3 bgcolor=#cccccc width=100%><font size=4>";
              $contacts .= "<a name='n$k'/>";
              $contacts .= $this->nameList[$k];
              $contacts .= "</font></td><td><a href=#top>^</a></td></tr>";
              $contacts .= "<tr><td></td><td>" . $this->personList[$k] . "</td></tr>";
              $contacts .= "</table>";
              $contacts .= "<br/>\n";
           }
        }

        $main .= $contacts;
        
        return $main;     
    }
}

?>

