<?php
require_once 'system/setup.conf';
require_once 'styles/styles.inc';
require_once 'warp/warplib/applet.inc';
require_once 'warp/warplib/appletutils.inc';

class Warp_Main_Applet extends Warp_Applet
{
var $style;

    function Warp_Main_Applet($caption = "Minerva")
    {
        parent::__construct($caption);
    }

    function init(&$appMan)
    {
       parent::init($appMan);

       $this->room = "bedroom";
       $this->configList = file("/usr/local/minerva/conf/rooms/" . $this->room);

       $this->style = $appMan->QueryParameter($this, "style");
       $styleCmd = $appMan->QueryParameter($this, "dostyle");
       if ($styleCmd != "") {
          $this->style = $styleCmd;
       }
    }

    function getRefreshParams(&$app_man)
    {
       $ref = $app_man->getArgument($this, "style", $this->style);
       return $ref;
    }

    function getDirectory()
    {
       return "main";
    }

    function renderPanel(&$appMan) 
    {
       $main = "";
       if (class_exists('MasterBar') && $appMan->getMaximisedAppletID() == $this->getID($appMan)) {
          $main .= $appMan->getMasterBarPanel(MasterBar::getPages($appMan));
       }
       return $main;
    }

    function getOutput($cmd) {
       $cmd = "/usr/local/minerva/bin/$cmd";
       $output = array();
        exec("$cmd", $output);
        $line = join($output, "<br>");
        return $line;
    }

    function getControl($img, $device, $cmd, $param, $value)
    {
        $device=trim($device);
        $param=trim($param);
        $value=trim($value);

        $control = "";
        $url = $this->getPathStub()."/ajaxget.php?room=".$this->room."&device=$device&cmd=$cmd&param=$param&value=$value";

        $fn = uniqid("fn");
$control .= "<a href='#' onclick='$fn();return false;'>$img</a>";
$control .= <<< EOT
<script language="Javascript">
function {$fn}()
{
           xmlhttpPost("$url", "", "status");
}
</script>

EOT;

        return $control;
    }

    function getImage($name) 
    {
        return "<img src='" . $this->getPathStub()."/images/icon_$name.png'>";
    }

    function getBlock(&$appMan, $type)
    {
        $cmdList = array(
            "audio" => array("quiet" => "quiet", "toggle"=>"toggle", "loud"=>"loud"),
            "manifest" => array("next" => "next", "block"=>"block", "pause"=>"pause", "play"=>"resume"),
            "house" => array("off" => "off", "minus"=>"dim", "plus"=>"bright", "on"=>"on"),
				"routine" => array("on" => "process"),
				"report" => array("on" => "html", "loud" => "say"),
        );

        $block = "";
        $block .= "";

        foreach($this->configList as $dev) {
           $s = split(':', $dev);
           if ($s[0] == $type) {
					if ($s[1] == "") {
						$s[1] = "default";
					}
					$name = ucwords($s[2]);

					if (isset($s[3])) {
						$name = $s[3];
					}

					// Mangle the name, automatically
					if ($type == "routine") {
						$name = shell_exec("/usr/local/minerva/bin/routine name $s[2]");
					}

					//

               $block .= "<b>$name</b>" . (($s[1] == "default") ? "" : "<i>($s[1])</i>") . "<br>";
               foreach($cmdList[$type] as $icon=>$param) {
                   $block .= $this->getControl($this->getImage($icon), $s[1], $type, $param, $s[2]) . "&nbsp;";
               }
               $block .= "<br/>";
           }
        }

        return $block;
    }

    function renderWindow(&$appMan)
    {
         // Top right style control
         $main  = "";

         //$main .= $appmain;
			$main .= "<div align=right>";
         $img = $appMan->getImageReference("style_small", "Handheld tablet");
			$main .= $appMan->getAppletLink($this, "dostyle", STYLE_TABLET_SMALL, $img);

         $img = $appMan->getImageReference("style_large", "Full tablet");
			$main .= $appMan->getAppletLink($this, "dostyle", STYLE_TABLET_LARGE, $img);

         $img = $appMan->getImageReference("style_full", "Full: Desktop");
			$main .= $appMan->getAppletLink($this, "dostyle", STYLE_FULL, $img);
			$main .= "</div>";

         $blocks = array();
         $blocks[] = "<h2>Routines</h2>" .  $this->getBlock($appMan, "routine");
         $blocks[] = "<h2>Manifest</h2>" .  $this->getBlock($appMan, "manifest");
         $blocks[] = "<h2>Audio</h2>" .  $this->getBlock($appMan, "audio");

         $blocks[] = "<h2>Reports</h2>" .  $this->getBlock($appMan, "report");
         $blocks[] = "<h2>House Control</h2>" .  $this->getBlock($appMan, "house");

			$status = "<i>Last result:</i><br><div id='status'>None</div><br><br>";
         $blocks[] = $status;

         $main .= "<div align=center>".appletUtils::getGridedContent($blocks, 3)."</div>";

/*
         // the home page, where we have only ourselves running
         if ($appMan->getAppletCount() == 1) {
            $info = array();
            $info[] = $this->getOutput("weatherstatus");
            $info[] = "<div align=center><img src=index.png></div>";
            $info[] = $this->getOutput("media default status");
            $info[] = $this->getOutput("hacal life public all 0");
            $info[] = $this->getOutput("hacal culture public all 0");
            $info[] = $this->getOutput("report repeat null calendar 0");

            $main .= "<div align=center>".appletUtils::getGridedContent($info, 3)."</div>";
         }

         // All the applets, drawn as icons
        $idx = 0;
        $links = array();
        foreach($appMan->_applets as $key => $value)
        {
            $app =& $value->getApplet();
            if ($app != $this) {
                $id = $app->getID($appMan);
                $appmain = "<div align=center>";
                $appmain .= $appMan->getLinkBase().$appMan->getMaximiseURL($id);

                $icon = $app->getIconFullURL();
                $icon = "<img src='".$icon."' border=0/>";

                $appmain .= $appMan->getEndLinkBaseText($icon."<br/>".$app->getIconCaption());
                $appmain .= "</div>";
                $links[$idx] = $appmain ;
                ++$idx;
            }
        }

         $main .= "<div align=center>".appletUtils::getGridedContent($links, 3)."</div>";

*/
         return $main;
    }
}

?>
